<?php

namespace Cegid\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerOrderDocumentAddressType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCustomerOrderDocumentAddressType
 * @subpackage Arrays
 */
class ArrayOfCustomerOrderDocumentAddressType extends AbstractStructArrayBase
{
    /**
     * The CustomerOrderDocumentAddressType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $CustomerOrderDocumentAddressType;
    /**
     * Constructor method for ArrayOfCustomerOrderDocumentAddressType
     * @uses ArrayOfCustomerOrderDocumentAddressType::setCustomerOrderDocumentAddressType()
     * @param string[] $customerOrderDocumentAddressType
     */
    public function __construct(array $customerOrderDocumentAddressType = array())
    {
        $this
            ->setCustomerOrderDocumentAddressType($customerOrderDocumentAddressType);
    }
    /**
     * Get CustomerOrderDocumentAddressType value
     * @return string[]|null
     */
    public function getCustomerOrderDocumentAddressType()
    {
        return $this->CustomerOrderDocumentAddressType;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerOrderDocumentAddressType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerOrderDocumentAddressType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerOrderDocumentAddressTypeForArrayConstraintsFromSetCustomerOrderDocumentAddressType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem) {
            // validation for constraint: enumeration
            if (!\Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid($arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem)) {
                $invalidValues[] = is_object($arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem) ? get_class($arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem) : sprintf('%s(%s)', gettype($arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem), var_export($arrayOfCustomerOrderDocumentAddressTypeCustomerOrderDocumentAddressTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderDocumentAddressType', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \Cegid\EnumType\CustomerOrderDocumentAddressType::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerOrderDocumentAddressType value
     * @uses \Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderDocumentAddressType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerOrderDocumentAddressType
     * @return \Cegid\ArrayType\ArrayOfCustomerOrderDocumentAddressType
     */
    public function setCustomerOrderDocumentAddressType(array $customerOrderDocumentAddressType = array())
    {
        // validation for constraint: array
        if ('' !== ($customerOrderDocumentAddressTypeArrayErrorMessage = self::validateCustomerOrderDocumentAddressTypeForArrayConstraintsFromSetCustomerOrderDocumentAddressType($customerOrderDocumentAddressType))) {
            throw new \InvalidArgumentException($customerOrderDocumentAddressTypeArrayErrorMessage, __LINE__);
        }
        $this->CustomerOrderDocumentAddressType = $customerOrderDocumentAddressType;
        return $this;
    }
    /**
     * Add item to CustomerOrderDocumentAddressType value
     * @uses \Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderDocumentAddressType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfCustomerOrderDocumentAddressType
     */
    public function addToCustomerOrderDocumentAddressType($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderDocumentAddressType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderDocumentAddressType::getValidValues())), __LINE__);
        }
        $this->CustomerOrderDocumentAddressType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid()
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfCustomerOrderDocumentAddressType
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderDocumentAddressType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderDocumentAddressType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderDocumentAddressType::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerOrderDocumentAddressType
     */
    public function getAttributeName()
    {
        return 'CustomerOrderDocumentAddressType';
    }
}
