<?php

namespace Cegid\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
 * ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
 * @subpackage Arrays
 */
class ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp extends AbstractStructArrayBase
{
    /**
     * The CustomerOrderCancelStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $CustomerOrderCancelStatus;
    /**
     * Constructor method for ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
     * @uses ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp::setCustomerOrderCancelStatus()
     * @param string[] $customerOrderCancelStatus
     */
    public function __construct(array $customerOrderCancelStatus = array())
    {
        $this
            ->setCustomerOrderCancelStatus($customerOrderCancelStatus);
    }
    /**
     * Get CustomerOrderCancelStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getCustomerOrderCancelStatus()
    {
        return isset($this->CustomerOrderCancelStatus) ? $this->CustomerOrderCancelStatus : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerOrderCancelStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerOrderCancelStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerOrderCancelStatusForArrayConstraintsFromSetCustomerOrderCancelStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem) {
            // validation for constraint: enumeration
            if (!\Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid($arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem)) {
                $invalidValues[] = is_object($arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem) ? get_class($arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem) : sprintf('%s(%s)', gettype($arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem), var_export($arrayOfNullableOfCustomerOrderCancelStatusSELWU3QpCustomerOrderCancelStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderCancelStatus', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \Cegid\EnumType\CustomerOrderCancelStatus::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerOrderCancelStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderCancelStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerOrderCancelStatus
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
     */
    public function setCustomerOrderCancelStatus(array $customerOrderCancelStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($customerOrderCancelStatusArrayErrorMessage = self::validateCustomerOrderCancelStatusForArrayConstraintsFromSetCustomerOrderCancelStatus($customerOrderCancelStatus))) {
            throw new \InvalidArgumentException($customerOrderCancelStatusArrayErrorMessage, __LINE__);
        }
        if (is_null($customerOrderCancelStatus) || (is_array($customerOrderCancelStatus) && empty($customerOrderCancelStatus))) {
            unset($this->CustomerOrderCancelStatus);
        } else {
            $this->CustomerOrderCancelStatus = $customerOrderCancelStatus;
        }
        return $this;
    }
    /**
     * Add item to CustomerOrderCancelStatus value
     * @uses \Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderCancelStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
     */
    public function addToCustomerOrderCancelStatus($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderCancelStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderCancelStatus::getValidValues())), __LINE__);
        }
        $this->CustomerOrderCancelStatus[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid()
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderCancelStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderCancelStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderCancelStatus::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerOrderCancelStatus
     */
    public function getAttributeName()
    {
        return 'CustomerOrderCancelStatus';
    }
}
