<?php

namespace Cegid\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
 * ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
 * @subpackage Arrays
 */
class ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp extends AbstractStructArrayBase
{
    /**
     * The CustomerOrderFollowUpStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $CustomerOrderFollowUpStatus;
    /**
     * Constructor method for ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
     * @uses ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp::setCustomerOrderFollowUpStatus()
     * @param string[] $customerOrderFollowUpStatus
     */
    public function __construct(array $customerOrderFollowUpStatus = array())
    {
        $this
            ->setCustomerOrderFollowUpStatus($customerOrderFollowUpStatus);
    }
    /**
     * Get CustomerOrderFollowUpStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getCustomerOrderFollowUpStatus()
    {
        return isset($this->CustomerOrderFollowUpStatus) ? $this->CustomerOrderFollowUpStatus : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerOrderFollowUpStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerOrderFollowUpStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerOrderFollowUpStatusForArrayConstraintsFromSetCustomerOrderFollowUpStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem) {
            // validation for constraint: enumeration
            if (!\Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid($arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem)) {
                $invalidValues[] = is_object($arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem) ? get_class($arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem) : sprintf('%s(%s)', gettype($arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem), var_export($arrayOfNullableOfCustomerOrderFollowUpStatusSELWU3QpCustomerOrderFollowUpStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderFollowUpStatus', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \Cegid\EnumType\CustomerOrderFollowUpStatus::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerOrderFollowUpStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderFollowUpStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerOrderFollowUpStatus
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
     */
    public function setCustomerOrderFollowUpStatus(array $customerOrderFollowUpStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($customerOrderFollowUpStatusArrayErrorMessage = self::validateCustomerOrderFollowUpStatusForArrayConstraintsFromSetCustomerOrderFollowUpStatus($customerOrderFollowUpStatus))) {
            throw new \InvalidArgumentException($customerOrderFollowUpStatusArrayErrorMessage, __LINE__);
        }
        if (is_null($customerOrderFollowUpStatus) || (is_array($customerOrderFollowUpStatus) && empty($customerOrderFollowUpStatus))) {
            unset($this->CustomerOrderFollowUpStatus);
        } else {
            $this->CustomerOrderFollowUpStatus = $customerOrderFollowUpStatus;
        }
        return $this;
    }
    /**
     * Add item to CustomerOrderFollowUpStatus value
     * @uses \Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderFollowUpStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
     */
    public function addToCustomerOrderFollowUpStatus($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderFollowUpStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderFollowUpStatus::getValidValues())), __LINE__);
        }
        $this->CustomerOrderFollowUpStatus[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid()
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderFollowUpStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderFollowUpStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderFollowUpStatus::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerOrderFollowUpStatus
     */
    public function getAttributeName()
    {
        return 'CustomerOrderFollowUpStatus';
    }
}
