<?php

namespace Cegid\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp
 * @subpackage Arrays
 */
class ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp extends AbstractStructArrayBase
{
    /**
     * The CustomerOrderVisaStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $CustomerOrderVisaStatus;
    /**
     * Constructor method for ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp
     * @uses ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp::setCustomerOrderVisaStatus()
     * @param string[] $customerOrderVisaStatus
     */
    public function __construct(array $customerOrderVisaStatus = array())
    {
        $this
            ->setCustomerOrderVisaStatus($customerOrderVisaStatus);
    }
    /**
     * Get CustomerOrderVisaStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getCustomerOrderVisaStatus()
    {
        return isset($this->CustomerOrderVisaStatus) ? $this->CustomerOrderVisaStatus : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerOrderVisaStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerOrderVisaStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerOrderVisaStatusForArrayConstraintsFromSetCustomerOrderVisaStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem) {
            // validation for constraint: enumeration
            if (!\Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid($arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem)) {
                $invalidValues[] = is_object($arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem) ? get_class($arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem) : sprintf('%s(%s)', gettype($arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem), var_export($arrayOfNullableOfCustomerOrderVisaStatusSELWU3QpCustomerOrderVisaStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderVisaStatus', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \Cegid\EnumType\CustomerOrderVisaStatus::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerOrderVisaStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderVisaStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerOrderVisaStatus
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp
     */
    public function setCustomerOrderVisaStatus(array $customerOrderVisaStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($customerOrderVisaStatusArrayErrorMessage = self::validateCustomerOrderVisaStatusForArrayConstraintsFromSetCustomerOrderVisaStatus($customerOrderVisaStatus))) {
            throw new \InvalidArgumentException($customerOrderVisaStatusArrayErrorMessage, __LINE__);
        }
        if (is_null($customerOrderVisaStatus) || (is_array($customerOrderVisaStatus) && empty($customerOrderVisaStatus))) {
            unset($this->CustomerOrderVisaStatus);
        } else {
            $this->CustomerOrderVisaStatus = $customerOrderVisaStatus;
        }
        return $this;
    }
    /**
     * Add item to CustomerOrderVisaStatus value
     * @uses \Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderVisaStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp
     */
    public function addToCustomerOrderVisaStatus($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderVisaStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderVisaStatus::getValidValues())), __LINE__);
        }
        $this->CustomerOrderVisaStatus[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid()
     * @param string $item
     * @return \Cegid\ArrayType\ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderVisaStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderVisaStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \Cegid\EnumType\CustomerOrderVisaStatus::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerOrderVisaStatus
     */
    public function getAttributeName()
    {
        return 'CustomerOrderVisaStatus';
    }
}
