<?php

namespace Cegid\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserFieldForPost ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUserFieldForPost
 * @subpackage Arrays
 */
class ArrayOfUserFieldForPost extends AbstractStructArrayBase
{
    /**
     * The UserFieldForPost
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\UserFieldForPost[]
     */
    public $UserFieldForPost;
    /**
     * Constructor method for ArrayOfUserFieldForPost
     * @uses ArrayOfUserFieldForPost::setUserFieldForPost()
     * @param \Cegid\StructType\UserFieldForPost[] $userFieldForPost
     */
    public function __construct(array $userFieldForPost = array())
    {
        $this
            ->setUserFieldForPost($userFieldForPost);
    }
    /**
     * Get UserFieldForPost value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\UserFieldForPost[]|null
     */
    public function getUserFieldForPost()
    {
        return isset($this->UserFieldForPost) ? $this->UserFieldForPost : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserFieldForPost method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserFieldForPost method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserFieldForPostForArrayConstraintsFromSetUserFieldForPost(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserFieldForPostUserFieldForPostItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserFieldForPostUserFieldForPostItem instanceof \Cegid\StructType\UserFieldForPost) {
                $invalidValues[] = is_object($arrayOfUserFieldForPostUserFieldForPostItem) ? get_class($arrayOfUserFieldForPostUserFieldForPostItem) : sprintf('%s(%s)', gettype($arrayOfUserFieldForPostUserFieldForPostItem), var_export($arrayOfUserFieldForPostUserFieldForPostItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserFieldForPost property can only contain items of type \Cegid\StructType\UserFieldForPost, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserFieldForPost value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\UserFieldForPost[] $userFieldForPost
     * @return \Cegid\ArrayType\ArrayOfUserFieldForPost
     */
    public function setUserFieldForPost(array $userFieldForPost = array())
    {
        // validation for constraint: array
        if ('' !== ($userFieldForPostArrayErrorMessage = self::validateUserFieldForPostForArrayConstraintsFromSetUserFieldForPost($userFieldForPost))) {
            throw new \InvalidArgumentException($userFieldForPostArrayErrorMessage, __LINE__);
        }
        if (is_null($userFieldForPost) || (is_array($userFieldForPost) && empty($userFieldForPost))) {
            unset($this->UserFieldForPost);
        } else {
            $this->UserFieldForPost = $userFieldForPost;
        }
        return $this;
    }
    /**
     * Add item to UserFieldForPost value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\UserFieldForPost $item
     * @return \Cegid\ArrayType\ArrayOfUserFieldForPost
     */
    public function addToUserFieldForPost(\Cegid\StructType\UserFieldForPost $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\UserFieldForPost) {
            throw new \InvalidArgumentException(sprintf('The UserFieldForPost property can only contain items of type \Cegid\StructType\UserFieldForPost, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserFieldForPost[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Cegid\StructType\UserFieldForPost|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Cegid\StructType\UserFieldForPost|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Cegid\StructType\UserFieldForPost|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Cegid\StructType\UserFieldForPost|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Cegid\StructType\UserFieldForPost|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserFieldForPost
     */
    public function getAttributeName()
    {
        return 'UserFieldForPost';
    }
}
