<?php

namespace Cegid;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HelloWorld' => '\\Cegid\\StructType\\HelloWorld',
            'RetailContext' => '\\Cegid\\StructType\\RetailContext',
            'HelloWorldResponse' => '\\Cegid\\StructType\\HelloWorldResponse',
            'Close' => '\\Cegid\\StructType\\Close',
            'CloseRequest' => '\\Cegid\\StructType\\CloseRequest',
            'CloseRequestKey' => '\\Cegid\\StructType\\CloseRequestKey',
            'CloseResponse' => '\\Cegid\\StructType\\CloseResponse',
            'CloseReply' => '\\Cegid\\StructType\\CloseReply',
            'Create' => '\\Cegid\\StructType\\Create',
            'CreateRequest' => '\\Cegid\\StructType\\CreateRequest',
            'CreateRequestHeader' => '\\Cegid\\StructType\\CreateRequestHeader',
            'CreateRequestHeaderCustomer' => '\\Cegid\\StructType\\CreateRequestHeaderCustomer',
            'CreateRequestHeaderCustomerAddressCollection' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddressCollection',
            'CreateRequestHeaderCustomerAddress' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddress',
            'CreateRequestHeaderCustomerAddressCompany' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddressCompany',
            'CreateRequestHeaderCustomerAddressIndividual' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddressIndividual',
            'CreateRequestHeaderCustomerAddressLineCollection' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddressLineCollection',
            'CreateRequestHeaderCustomerAddressLine' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerAddressLine',
            'ArrayOfCustomerOrderDocumentAddressType' => '\\Cegid\\ArrayType\\ArrayOfCustomerOrderDocumentAddressType',
            'CreateRequestHeaderCustomerIdentifier' => '\\Cegid\\StructType\\CreateRequestHeaderCustomerIdentifier',
            'CreateRequestHeaderEmployeeCollection' => '\\Cegid\\StructType\\CreateRequestHeaderEmployeeCollection',
            'CreateRequestHeaderEmployee' => '\\Cegid\\StructType\\CreateRequestHeaderEmployee',
            'CreateRequestHeaderReferences' => '\\Cegid\\StructType\\CreateRequestHeaderReferences',
            'CreateRequestHeaderStoreIdentifier' => '\\Cegid\\StructType\\CreateRequestHeaderStoreIdentifier',
            'CreateRequestHeaderUserDefined' => '\\Cegid\\StructType\\CreateRequestHeaderUserDefined',
            'CreateRequestHeaderUserDefinedDateCollection' => '\\Cegid\\StructType\\CreateRequestHeaderUserDefinedDateCollection',
            'CreateRequestHeaderUserDefinedDate' => '\\Cegid\\StructType\\CreateRequestHeaderUserDefinedDate',
            'CreateRequestHeaderUserDefinedTableCollection' => '\\Cegid\\StructType\\CreateRequestHeaderUserDefinedTableCollection',
            'CreateRequestHeaderUserDefinedTable' => '\\Cegid\\StructType\\CreateRequestHeaderUserDefinedTable',
            'ArrayOfUserFieldForPost' => '\\Cegid\\ArrayType\\ArrayOfUserFieldForPost',
            'UserFieldForPost' => '\\Cegid\\StructType\\UserFieldForPost',
            'UserFieldForPostValue' => '\\Cegid\\StructType\\UserFieldForPostValue',
            'CreateRequestHeaderWarehouseIdentifier' => '\\Cegid\\StructType\\CreateRequestHeaderWarehouseIdentifier',
            'CreateRequestLineCollection' => '\\Cegid\\StructType\\CreateRequestLineCollection',
            'CreateRequestLine' => '\\Cegid\\StructType\\CreateRequestLine',
            'CreateRequestLineComment' => '\\Cegid\\StructType\\CreateRequestLineComment',
            'CreateRequestLineProduct' => '\\Cegid\\StructType\\CreateRequestLineProduct',
            'CreateRequestLineProductDiscountCollection' => '\\Cegid\\StructType\\CreateRequestLineProductDiscountCollection',
            'CreateRequestLineProductDiscount' => '\\Cegid\\StructType\\CreateRequestLineProductDiscount',
            'CreateRequestLineProductItemIdentifier' => '\\Cegid\\StructType\\CreateRequestLineProductItemIdentifier',
            'CreateRequestLineProductReferences' => '\\Cegid\\StructType\\CreateRequestLineProductReferences',
            'DocumentAmount' => '\\Cegid\\StructType\\DocumentAmount',
            'DocumentAmountTotal' => '\\Cegid\\StructType\\DocumentAmountTotal',
            'DocumentAmountUnitPrice' => '\\Cegid\\StructType\\DocumentAmountUnitPrice',
            'CreateRequestLineProductTaxCollection' => '\\Cegid\\StructType\\CreateRequestLineProductTaxCollection',
            'CreateRequestLineProductTax' => '\\Cegid\\StructType\\CreateRequestLineProductTax',
            'CreateRequestLineProductWarehouseIdentifier' => '\\Cegid\\StructType\\CreateRequestLineProductWarehouseIdentifier',
            'CreateResponse' => '\\Cegid\\StructType\\CreateResponse',
            'CreateReply' => '\\Cegid\\StructType\\CreateReply',
            'CreateReplyDocument' => '\\Cegid\\StructType\\CreateReplyDocument',
            'CreateReplyDocumentKey' => '\\Cegid\\StructType\\CreateReplyDocumentKey',
            'CreateFrom' => '\\Cegid\\StructType\\CreateFrom',
            'CreateFromRequest' => '\\Cegid\\StructType\\CreateFromRequest',
            'CreateFromRequestHeader' => '\\Cegid\\StructType\\CreateFromRequestHeader',
            'CreateFromRequestHeaderOriginalDocumentIdentifier' => '\\Cegid\\StructType\\CreateFromRequestHeaderOriginalDocumentIdentifier',
            'CreateFromRequestHeaderOriginalDocumentIdentifierKey' => '\\Cegid\\StructType\\CreateFromRequestHeaderOriginalDocumentIdentifierKey',
            'CreateFromRequestHeaderOriginalDocumentIdentifierReference' => '\\Cegid\\StructType\\CreateFromRequestHeaderOriginalDocumentIdentifierReference',
            'CreateFromRequestHeaderRemainderManagement' => '\\Cegid\\StructType\\CreateFromRequestHeaderRemainderManagement',
            'CreateFromRequestHeaderUserDefinedDateCollection' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedDateCollection',
            'CreateFromRequestHeaderUserDefinedDate' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedDate',
            'CreateFromRequestHeaderUserDefinedTableCustomerCollection' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedTableCustomerCollection',
            'CreateFromRequestHeaderUserDefinedTableCustomer' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedTableCustomer',
            'CreateFromRequestHeaderUserDefinedTableCollection' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedTableCollection',
            'CreateFromRequestHeaderUserDefinedTable' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserDefinedTable',
            'CreateFromRequestHeaderUserFieldCollection' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserFieldCollection',
            'CreateFromRequestHeaderUserField' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserField',
            'CreateFromRequestHeaderUserFieldValue' => '\\Cegid\\StructType\\CreateFromRequestHeaderUserFieldValue',
            'CreateFromRequestLineCollection' => '\\Cegid\\StructType\\CreateFromRequestLineCollection',
            'CreateFromRequestLine' => '\\Cegid\\StructType\\CreateFromRequestLine',
            'CreateFromRequestLineItemIdentifier' => '\\Cegid\\StructType\\CreateFromRequestLineItemIdentifier',
            'CreateFromRequestPaymentCollection' => '\\Cegid\\StructType\\CreateFromRequestPaymentCollection',
            'CreateFromRequestPayment' => '\\Cegid\\StructType\\CreateFromRequestPayment',
            'CreateFromRequestPaymentCreditCard' => '\\Cegid\\StructType\\CreateFromRequestPaymentCreditCard',
            'CreateFromRequestPaymentReceivedPayment' => '\\Cegid\\StructType\\CreateFromRequestPaymentReceivedPayment',
            'CreateFromResponse' => '\\Cegid\\StructType\\CreateFromResponse',
            'CreateFromReply' => '\\Cegid\\StructType\\CreateFromReply',
            'CreateFromReplyDocumentCollection' => '\\Cegid\\StructType\\CreateFromReplyDocumentCollection',
            'CreateFromReplyDocument' => '\\Cegid\\StructType\\CreateFromReplyDocument',
            'CreateFromReplyDocumentKey' => '\\Cegid\\StructType\\CreateFromReplyDocumentKey',
            'CreateFrom2' => '\\Cegid\\StructType\\CreateFrom2',
            'CreateFrom2Request' => '\\Cegid\\StructType\\CreateFrom2Request',
            'CreateFrom2RequestHeader' => '\\Cegid\\StructType\\CreateFrom2RequestHeader',
            'CreateFrom2RequestHeaderKey' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderKey',
            'CreateFrom2RequestHeaderOmniChannel' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderOmniChannel',
            'CreateFrom2RequestHeaderReferences' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderReferences',
            'CreateFrom2RequestHeaderRemainderManagement' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderRemainderManagement',
            'CreateFrom2RequestHeaderUserDefined' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefined',
            'CreateFrom2RequestHeaderUserDefinedCustomerTableCollection' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedCustomerTableCollection',
            'CreateFrom2RequestHeaderUserDefinedCustomerTable' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedCustomerTable',
            'CreateFrom2RequestHeaderUserDefinedDateCollection' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedDateCollection',
            'CreateFrom2RequestHeaderUserDefinedDate' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedDate',
            'CreateFrom2RequestHeaderUserDefinedTableCollection' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedTableCollection',
            'CreateFrom2RequestHeaderUserDefinedTable' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserDefinedTable',
            'CreateFrom2RequestHeaderUserFieldCollection' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserFieldCollection',
            'CreateFrom2RequestHeaderUserField' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserField',
            'CreateFrom2RequestHeaderUserFieldValue' => '\\Cegid\\StructType\\CreateFrom2RequestHeaderUserFieldValue',
            'CreateFrom2RequestLineCollection' => '\\Cegid\\StructType\\CreateFrom2RequestLineCollection',
            'CreateFrom2RequestLine' => '\\Cegid\\StructType\\CreateFrom2RequestLine',
            'CreateFrom2RequestLineItemIdentifier' => '\\Cegid\\StructType\\CreateFrom2RequestLineItemIdentifier',
            'CreateFrom2RequestLineReferences' => '\\Cegid\\StructType\\CreateFrom2RequestLineReferences',
            'CreateFrom2RequestPaymentCollection' => '\\Cegid\\StructType\\CreateFrom2RequestPaymentCollection',
            'CreateFrom2RequestPayment' => '\\Cegid\\StructType\\CreateFrom2RequestPayment',
            'CreateFrom2RequestPaymentCreditCard' => '\\Cegid\\StructType\\CreateFrom2RequestPaymentCreditCard',
            'CreateFrom2RequestPaymentReceivedPayment' => '\\Cegid\\StructType\\CreateFrom2RequestPaymentReceivedPayment',
            'CreateFrom2Response' => '\\Cegid\\StructType\\CreateFrom2Response',
            'CreateFrom2Reply' => '\\Cegid\\StructType\\CreateFrom2Reply',
            'CreateFrom2ReplyDocumentCollection' => '\\Cegid\\StructType\\CreateFrom2ReplyDocumentCollection',
            'CreateFrom2ReplyDocument' => '\\Cegid\\StructType\\CreateFrom2ReplyDocument',
            'CreateFrom2ReplyDocumentKey' => '\\Cegid\\StructType\\CreateFrom2ReplyDocumentKey',
            'GetDetail' => '\\Cegid\\StructType\\GetDetail',
            'GetDetailRequest' => '\\Cegid\\StructType\\GetDetailRequest',
            'ArrayOfFieldsType' => '\\Cegid\\ArrayType\\ArrayOfFieldsType',
            'GetDetailResponse' => '\\Cegid\\StructType\\GetDetailResponse',
            'GetDetailReply' => '\\Cegid\\StructType\\GetDetailReply',
            'CustomerOrder' => '\\Cegid\\StructType\\CustomerOrder',
            'CustomerOrderHeader' => '\\Cegid\\StructType\\CustomerOrderHeader',
            'ArrayOfAddress' => '\\Cegid\\ArrayType\\ArrayOfAddress',
            'Address' => '\\Cegid\\StructType\\Address',
            'AddressCompany' => '\\Cegid\\StructType\\AddressCompany',
            'AddressIndividual' => '\\Cegid\\StructType\\AddressIndividual',
            'AddressLineCollection' => '\\Cegid\\StructType\\AddressLineCollection',
            'AddressLine' => '\\Cegid\\StructType\\AddressLine',
            'CustomerOrderHeaderCustomer' => '\\Cegid\\StructType\\CustomerOrderHeaderCustomer',
            'CustomerOrderHeaderCustomerEmailCollection' => '\\Cegid\\StructType\\CustomerOrderHeaderCustomerEmailCollection',
            'CustomerOrderHeaderCustomerEmail' => '\\Cegid\\StructType\\CustomerOrderHeaderCustomerEmail',
            'CustomerOrderHeaderCustomerPhoneCollection' => '\\Cegid\\StructType\\CustomerOrderHeaderCustomerPhoneCollection',
            'CustomerOrderHeaderCustomerPhone' => '\\Cegid\\StructType\\CustomerOrderHeaderCustomerPhone',
            'CustomerOrderHeaderDocumentKey' => '\\Cegid\\StructType\\CustomerOrderHeaderDocumentKey',
            'CustomerOrderHeaderOmniChannel' => '\\Cegid\\StructType\\CustomerOrderHeaderOmniChannel',
            'CustomerOrderHeaderOmniChannelGiftMessage' => '\\Cegid\\StructType\\CustomerOrderHeaderOmniChannelGiftMessage',
            'CustomerOrderHeaderReferences' => '\\Cegid\\StructType\\CustomerOrderHeaderReferences',
            'ArrayOfUserDefinedTable' => '\\Cegid\\ArrayType\\ArrayOfUserDefinedTable',
            'UserDefinedTable' => '\\Cegid\\StructType\\UserDefinedTable',
            'ArrayOfUserField' => '\\Cegid\\ArrayType\\ArrayOfUserField',
            'UserField' => '\\Cegid\\StructType\\UserField',
            'UserFieldValue' => '\\Cegid\\StructType\\UserFieldValue',
            'UserFieldValueListElement' => '\\Cegid\\StructType\\UserFieldValueListElement',
            'CustomerOrderLineCollection' => '\\Cegid\\StructType\\CustomerOrderLineCollection',
            'CustomerOrderLine' => '\\Cegid\\StructType\\CustomerOrderLine',
            'CustomerOrderLineDiscountCollection' => '\\Cegid\\StructType\\CustomerOrderLineDiscountCollection',
            'CustomerOrderLineDiscount' => '\\Cegid\\StructType\\CustomerOrderLineDiscount',
            'CustomerOrderLineItem' => '\\Cegid\\StructType\\CustomerOrderLineItem',
            'CustomerOrderLineLinkedDocumentCollection' => '\\Cegid\\StructType\\CustomerOrderLineLinkedDocumentCollection',
            'CustomerOrderLineLinkedDocument' => '\\Cegid\\StructType\\CustomerOrderLineLinkedDocument',
            'CustomerOrderLineLinkedDocumentKey' => '\\Cegid\\StructType\\CustomerOrderLineLinkedDocumentKey',
            'CustomerOrderLineQuantities' => '\\Cegid\\StructType\\CustomerOrderLineQuantities',
            'CustomerOrderLineTaxCollection' => '\\Cegid\\StructType\\CustomerOrderLineTaxCollection',
            'CustomerOrderLineTax' => '\\Cegid\\StructType\\CustomerOrderLineTax',
            'GetListDetail' => '\\Cegid\\StructType\\GetListDetail',
            'GetListDetailRequest' => '\\Cegid\\StructType\\GetListDetailRequest',
            'GetListDetailRequestOmniChannel' => '\\Cegid\\StructType\\GetListDetailRequestOmniChannel',
            'Paging' => '\\Cegid\\StructType\\Paging',
            'GetListDetailRequestSearchDate' => '\\Cegid\\StructType\\GetListDetailRequestSearchDate',
            'GetListDetailResponse' => '\\Cegid\\StructType\\GetListDetailResponse',
            'GetListDetailReply' => '\\Cegid\\StructType\\GetListDetailReply',
            'ArrayOfCustomerOrder' => '\\Cegid\\ArrayType\\ArrayOfCustomerOrder',
            'Pagination' => '\\Cegid\\StructType\\Pagination',
            'Refuse' => '\\Cegid\\StructType\\Refuse',
            'RefuseRequest' => '\\Cegid\\StructType\\RefuseRequest',
            'RefuseRequestKey' => '\\Cegid\\StructType\\RefuseRequestKey',
            'RefuseResponse' => '\\Cegid\\StructType\\RefuseResponse',
            'RefuseReply' => '\\Cegid\\StructType\\RefuseReply',
            'Replace' => '\\Cegid\\StructType\\Replace',
            'ReplaceRequest' => '\\Cegid\\StructType\\ReplaceRequest',
            'ReplaceRequestHeader' => '\\Cegid\\StructType\\ReplaceRequestHeader',
            'ReplaceRequestHeaderCustomer' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomer',
            'ReplaceRequestHeaderCustomerAddressCollection' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddressCollection',
            'ReplaceRequestHeaderCustomerAddress' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddress',
            'ReplaceRequestHeaderCustomerAddressCompany' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddressCompany',
            'ReplaceRequestHeaderCustomerAddressIndividual' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddressIndividual',
            'ReplaceRequestHeaderCustomerAddressLineCollection' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddressLineCollection',
            'ReplaceRequestHeaderCustomerAddressLine' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerAddressLine',
            'ReplaceRequestHeaderCustomerIdentifier' => '\\Cegid\\StructType\\ReplaceRequestHeaderCustomerIdentifier',
            'ReplaceRequestHeaderEmployeeCollection' => '\\Cegid\\StructType\\ReplaceRequestHeaderEmployeeCollection',
            'ReplaceRequestHeaderEmployee' => '\\Cegid\\StructType\\ReplaceRequestHeaderEmployee',
            'ReplaceRequestHeaderKey' => '\\Cegid\\StructType\\ReplaceRequestHeaderKey',
            'ReplaceRequestHeaderOmniChannel' => '\\Cegid\\StructType\\ReplaceRequestHeaderOmniChannel',
            'ReplaceRequestHeaderReferences' => '\\Cegid\\StructType\\ReplaceRequestHeaderReferences',
            'ReplaceRequestHeaderStoreIdentifier' => '\\Cegid\\StructType\\ReplaceRequestHeaderStoreIdentifier',
            'ReplaceRequestHeaderUserDefined' => '\\Cegid\\StructType\\ReplaceRequestHeaderUserDefined',
            'ReplaceRequestHeaderUserDefinedDateCollection' => '\\Cegid\\StructType\\ReplaceRequestHeaderUserDefinedDateCollection',
            'ReplaceRequestHeaderUserDefinedDate' => '\\Cegid\\StructType\\ReplaceRequestHeaderUserDefinedDate',
            'ReplaceRequestHeaderUserDefinedTableCollection' => '\\Cegid\\StructType\\ReplaceRequestHeaderUserDefinedTableCollection',
            'ReplaceRequestHeaderUserDefinedTable' => '\\Cegid\\StructType\\ReplaceRequestHeaderUserDefinedTable',
            'ReplaceRequestHeaderWarehouseIdentifier' => '\\Cegid\\StructType\\ReplaceRequestHeaderWarehouseIdentifier',
            'ReplaceRequestLineCollection' => '\\Cegid\\StructType\\ReplaceRequestLineCollection',
            'ReplaceRequestLine' => '\\Cegid\\StructType\\ReplaceRequestLine',
            'ReplaceRequestLineComment' => '\\Cegid\\StructType\\ReplaceRequestLineComment',
            'ReplaceRequestLineProduct' => '\\Cegid\\StructType\\ReplaceRequestLineProduct',
            'ReplaceRequestLineProductDiscountCollection' => '\\Cegid\\StructType\\ReplaceRequestLineProductDiscountCollection',
            'ReplaceRequestLineProductDiscount' => '\\Cegid\\StructType\\ReplaceRequestLineProductDiscount',
            'ReplaceRequestLineProductItemIdentifier' => '\\Cegid\\StructType\\ReplaceRequestLineProductItemIdentifier',
            'ReplaceRequestLineProductReferences' => '\\Cegid\\StructType\\ReplaceRequestLineProductReferences',
            'ReplaceRequestLineProductTaxCollection' => '\\Cegid\\StructType\\ReplaceRequestLineProductTaxCollection',
            'ReplaceRequestLineProductTax' => '\\Cegid\\StructType\\ReplaceRequestLineProductTax',
            'ReplaceRequestLineProductWarehouseIdentifier' => '\\Cegid\\StructType\\ReplaceRequestLineProductWarehouseIdentifier',
            'ReplaceResponse' => '\\Cegid\\StructType\\ReplaceResponse',
            'Update' => '\\Cegid\\StructType\\Update',
            'UpdateRequest' => '\\Cegid\\StructType\\UpdateRequest',
            'UpdateRequestHeader' => '\\Cegid\\StructType\\UpdateRequestHeader',
            'UpdateRequestHeaderEmployeeCollection' => '\\Cegid\\StructType\\UpdateRequestHeaderEmployeeCollection',
            'UpdateRequestHeaderEmployee' => '\\Cegid\\StructType\\UpdateRequestHeaderEmployee',
            'UpdateRequestHeaderReferences' => '\\Cegid\\StructType\\UpdateRequestHeaderReferences',
            'UpdateRequestHeaderUserDefined' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefined',
            'UpdateRequestHeaderUserDefinedCustomerTableCollection' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedCustomerTableCollection',
            'UpdateRequestHeaderUserDefinedCustomerTable' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedCustomerTable',
            'UpdateRequestHeaderUserDefinedDateCollection' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedDateCollection',
            'UpdateRequestHeaderUserDefinedDate' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedDate',
            'UpdateRequestHeaderUserDefinedTableCollection' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedTableCollection',
            'UpdateRequestHeaderUserDefinedTable' => '\\Cegid\\StructType\\UpdateRequestHeaderUserDefinedTable',
            'UpdateRequestKey' => '\\Cegid\\StructType\\UpdateRequestKey',
            'UpdateResponse' => '\\Cegid\\StructType\\UpdateResponse',
            'ExceptionDetail' => '\\Cegid\\StructType\\ExceptionDetail',
            'CbpExceptionDetail' => '\\Cegid\\StructType\\CbpExceptionDetail',
            'ArrayOfstring' => '\\Cegid\\ArrayType\\ArrayOfstring',
            'ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp' => '\\Cegid\\ArrayType\\ArrayOfNullableOfCustomerOrderCancelStatusSELWU3Qp',
            'ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp' => '\\Cegid\\ArrayType\\ArrayOfNullableOfCustomerOrderFollowUpStatusSELWU3Qp',
            'ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp' => '\\Cegid\\ArrayType\\ArrayOfNullableOfCustomerOrderVisaStatusSELWU3Qp',
        );
    }
}
