<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddressLineCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AddressLineCollection
 * @subpackage Structs
 */
class AddressLineCollection extends AbstractStructBase
{
    /**
     * The Line
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\AddressLine[]
     */
    public $Line;
    /**
     * Constructor method for AddressLineCollection
     * @uses AddressLineCollection::setLine()
     * @param \Cegid\StructType\AddressLine[] $line
     */
    public function __construct(array $line = array())
    {
        $this
            ->setLine($line);
    }
    /**
     * Get Line value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\AddressLine[]|null
     */
    public function getLine()
    {
        return isset($this->Line) ? $this->Line : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLine method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLine method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLineForArrayConstraintsFromSetLine(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $addressLineCollectionLineItem) {
            // validation for constraint: itemType
            if (!$addressLineCollectionLineItem instanceof \Cegid\StructType\AddressLine) {
                $invalidValues[] = is_object($addressLineCollectionLineItem) ? get_class($addressLineCollectionLineItem) : sprintf('%s(%s)', gettype($addressLineCollectionLineItem), var_export($addressLineCollectionLineItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Line property can only contain items of type \Cegid\StructType\AddressLine, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Line value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\AddressLine[] $line
     * @return \Cegid\StructType\AddressLineCollection
     */
    public function setLine(array $line = array())
    {
        // validation for constraint: array
        if ('' !== ($lineArrayErrorMessage = self::validateLineForArrayConstraintsFromSetLine($line))) {
            throw new \InvalidArgumentException($lineArrayErrorMessage, __LINE__);
        }
        if (is_null($line) || (is_array($line) && empty($line))) {
            unset($this->Line);
        } else {
            $this->Line = $line;
        }
        return $this;
    }
    /**
     * Add item to Line value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\AddressLine $item
     * @return \Cegid\StructType\AddressLineCollection
     */
    public function addToLine(\Cegid\StructType\AddressLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\AddressLine) {
            throw new \InvalidArgumentException(sprintf('The Line property can only contain items of type \Cegid\StructType\AddressLine, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Line[] = $item;
        return $this;
    }
}
