<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFrom2Reply StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFrom2Reply
 * @subpackage Structs
 */
class CreateFrom2Reply extends AbstractStructBase
{
    /**
     * The DocumentCreated
     * @var bool
     */
    public $DocumentCreated;
    /**
     * The Documents
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2ReplyDocumentCollection
     */
    public $Documents;
    /**
     * Constructor method for CreateFrom2Reply
     * @uses CreateFrom2Reply::setDocumentCreated()
     * @uses CreateFrom2Reply::setDocuments()
     * @param bool $documentCreated
     * @param \Cegid\StructType\CreateFrom2ReplyDocumentCollection $documents
     */
    public function __construct($documentCreated = null, \Cegid\StructType\CreateFrom2ReplyDocumentCollection $documents = null)
    {
        $this
            ->setDocumentCreated($documentCreated)
            ->setDocuments($documents);
    }
    /**
     * Get DocumentCreated value
     * @return bool|null
     */
    public function getDocumentCreated()
    {
        return $this->DocumentCreated;
    }
    /**
     * Set DocumentCreated value
     * @param bool $documentCreated
     * @return \Cegid\StructType\CreateFrom2Reply
     */
    public function setDocumentCreated($documentCreated = null)
    {
        // validation for constraint: boolean
        if (!is_null($documentCreated) && !is_bool($documentCreated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($documentCreated, true), gettype($documentCreated)), __LINE__);
        }
        $this->DocumentCreated = $documentCreated;
        return $this;
    }
    /**
     * Get Documents value
     * @return \Cegid\StructType\CreateFrom2ReplyDocumentCollection|null
     */
    public function getDocuments()
    {
        return $this->Documents;
    }
    /**
     * Set Documents value
     * @param \Cegid\StructType\CreateFrom2ReplyDocumentCollection $documents
     * @return \Cegid\StructType\CreateFrom2Reply
     */
    public function setDocuments(\Cegid\StructType\CreateFrom2ReplyDocumentCollection $documents = null)
    {
        $this->Documents = $documents;
        return $this;
    }
}
