<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFrom2RequestHeader StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFrom2RequestHeader
 * @subpackage Structs
 */
class CreateFrom2RequestHeader extends AbstractStructBase
{
    /**
     * The DeviceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeviceId;
    /**
     * The DisableMergeLines
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $DisableMergeLines;
    /**
     * The DocumentDate
     * @var string
     */
    public $DocumentDate;
    /**
     * The ExpiryDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExpiryDate;
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderKey
     */
    public $Key;
    /**
     * The MovementReasonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MovementReasonId;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderOmniChannel
     */
    public $OmniChannel;
    /**
     * The OperationUid
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $OperationUid;
    /**
     * The References
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderReferences
     */
    public $References;
    /**
     * The RemainderManagement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement
     */
    public $RemainderManagement;
    /**
     * The SalespersonId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalespersonId;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The UserDefined
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderUserDefined
     */
    public $UserDefined;
    /**
     * The UserFields
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection
     */
    public $UserFields;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for CreateFrom2RequestHeader
     * @uses CreateFrom2RequestHeader::setDeviceId()
     * @uses CreateFrom2RequestHeader::setDisableMergeLines()
     * @uses CreateFrom2RequestHeader::setDocumentDate()
     * @uses CreateFrom2RequestHeader::setExpiryDate()
     * @uses CreateFrom2RequestHeader::setKey()
     * @uses CreateFrom2RequestHeader::setMovementReasonId()
     * @uses CreateFrom2RequestHeader::setOmniChannel()
     * @uses CreateFrom2RequestHeader::setOperationUid()
     * @uses CreateFrom2RequestHeader::setReferences()
     * @uses CreateFrom2RequestHeader::setRemainderManagement()
     * @uses CreateFrom2RequestHeader::setSalespersonId()
     * @uses CreateFrom2RequestHeader::setType()
     * @uses CreateFrom2RequestHeader::setUserDefined()
     * @uses CreateFrom2RequestHeader::setUserFields()
     * @uses CreateFrom2RequestHeader::setWarehouseId()
     * @param string $deviceId
     * @param bool $disableMergeLines
     * @param string $documentDate
     * @param string $expiryDate
     * @param \Cegid\StructType\CreateFrom2RequestHeaderKey $key
     * @param string $movementReasonId
     * @param \Cegid\StructType\CreateFrom2RequestHeaderOmniChannel $omniChannel
     * @param string $operationUid
     * @param \Cegid\StructType\CreateFrom2RequestHeaderReferences $references
     * @param \Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement $remainderManagement
     * @param string $salespersonId
     * @param string $type
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserDefined $userDefined
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection $userFields
     * @param string $warehouseId
     */
    public function __construct($deviceId = null, $disableMergeLines = null, $documentDate = null, $expiryDate = null, \Cegid\StructType\CreateFrom2RequestHeaderKey $key = null, $movementReasonId = null, \Cegid\StructType\CreateFrom2RequestHeaderOmniChannel $omniChannel = null, $operationUid = null, \Cegid\StructType\CreateFrom2RequestHeaderReferences $references = null, \Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement $remainderManagement = null, $salespersonId = null, $type = null, \Cegid\StructType\CreateFrom2RequestHeaderUserDefined $userDefined = null, \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection $userFields = null, $warehouseId = null)
    {
        $this
            ->setDeviceId($deviceId)
            ->setDisableMergeLines($disableMergeLines)
            ->setDocumentDate($documentDate)
            ->setExpiryDate($expiryDate)
            ->setKey($key)
            ->setMovementReasonId($movementReasonId)
            ->setOmniChannel($omniChannel)
            ->setOperationUid($operationUid)
            ->setReferences($references)
            ->setRemainderManagement($remainderManagement)
            ->setSalespersonId($salespersonId)
            ->setType($type)
            ->setUserDefined($userDefined)
            ->setUserFields($userFields)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get DeviceId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeviceId()
    {
        return isset($this->DeviceId) ? $this->DeviceId : null;
    }
    /**
     * Set DeviceId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deviceId
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setDeviceId($deviceId = null)
    {
        // validation for constraint: string
        if (!is_null($deviceId) && !is_string($deviceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceId, true), gettype($deviceId)), __LINE__);
        }
        if (is_null($deviceId) || (is_array($deviceId) && empty($deviceId))) {
            unset($this->DeviceId);
        } else {
            $this->DeviceId = $deviceId;
        }
        return $this;
    }
    /**
     * Get DisableMergeLines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getDisableMergeLines()
    {
        return isset($this->DisableMergeLines) ? $this->DisableMergeLines : null;
    }
    /**
     * Set DisableMergeLines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $disableMergeLines
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setDisableMergeLines($disableMergeLines = null)
    {
        // validation for constraint: boolean
        if (!is_null($disableMergeLines) && !is_bool($disableMergeLines)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($disableMergeLines, true), gettype($disableMergeLines)), __LINE__);
        }
        if (is_null($disableMergeLines) || (is_array($disableMergeLines) && empty($disableMergeLines))) {
            unset($this->DisableMergeLines);
        } else {
            $this->DisableMergeLines = $disableMergeLines;
        }
        return $this;
    }
    /**
     * Get DocumentDate value
     * @return string|null
     */
    public function getDocumentDate()
    {
        return $this->DocumentDate;
    }
    /**
     * Set DocumentDate value
     * @param string $documentDate
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setDocumentDate($documentDate = null)
    {
        // validation for constraint: string
        if (!is_null($documentDate) && !is_string($documentDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($documentDate, true), gettype($documentDate)), __LINE__);
        }
        $this->DocumentDate = $documentDate;
        return $this;
    }
    /**
     * Get ExpiryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExpiryDate()
    {
        return isset($this->ExpiryDate) ? $this->ExpiryDate : null;
    }
    /**
     * Set ExpiryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $expiryDate
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setExpiryDate($expiryDate = null)
    {
        // validation for constraint: string
        if (!is_null($expiryDate) && !is_string($expiryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiryDate, true), gettype($expiryDate)), __LINE__);
        }
        if (is_null($expiryDate) || (is_array($expiryDate) && empty($expiryDate))) {
            unset($this->ExpiryDate);
        } else {
            $this->ExpiryDate = $expiryDate;
        }
        return $this;
    }
    /**
     * Get Key value
     * @return \Cegid\StructType\CreateFrom2RequestHeaderKey|null
     */
    public function getKey()
    {
        return $this->Key;
    }
    /**
     * Set Key value
     * @param \Cegid\StructType\CreateFrom2RequestHeaderKey $key
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setKey(\Cegid\StructType\CreateFrom2RequestHeaderKey $key = null)
    {
        $this->Key = $key;
        return $this;
    }
    /**
     * Get MovementReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMovementReasonId()
    {
        return isset($this->MovementReasonId) ? $this->MovementReasonId : null;
    }
    /**
     * Set MovementReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $movementReasonId
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setMovementReasonId($movementReasonId = null)
    {
        // validation for constraint: string
        if (!is_null($movementReasonId) && !is_string($movementReasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($movementReasonId, true), gettype($movementReasonId)), __LINE__);
        }
        if (is_null($movementReasonId) || (is_array($movementReasonId) && empty($movementReasonId))) {
            unset($this->MovementReasonId);
        } else {
            $this->MovementReasonId = $movementReasonId;
        }
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderOmniChannel|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFrom2RequestHeaderOmniChannel $omniChannel
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setOmniChannel(\Cegid\StructType\CreateFrom2RequestHeaderOmniChannel $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get OperationUid value
     * @return string|null
     */
    public function getOperationUid()
    {
        return $this->OperationUid;
    }
    /**
     * Set OperationUid value
     * @param string $operationUid
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setOperationUid($operationUid = null)
    {
        // validation for constraint: string
        if (!is_null($operationUid) && !is_string($operationUid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($operationUid, true), gettype($operationUid)), __LINE__);
        }
        $this->OperationUid = $operationUid;
        return $this;
    }
    /**
     * Get References value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderReferences|null
     */
    public function getReferences()
    {
        return isset($this->References) ? $this->References : null;
    }
    /**
     * Set References value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFrom2RequestHeaderReferences $references
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setReferences(\Cegid\StructType\CreateFrom2RequestHeaderReferences $references = null)
    {
        if (is_null($references) || (is_array($references) && empty($references))) {
            unset($this->References);
        } else {
            $this->References = $references;
        }
        return $this;
    }
    /**
     * Get RemainderManagement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement|null
     */
    public function getRemainderManagement()
    {
        return isset($this->RemainderManagement) ? $this->RemainderManagement : null;
    }
    /**
     * Set RemainderManagement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement $remainderManagement
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setRemainderManagement(\Cegid\StructType\CreateFrom2RequestHeaderRemainderManagement $remainderManagement = null)
    {
        if (is_null($remainderManagement) || (is_array($remainderManagement) && empty($remainderManagement))) {
            unset($this->RemainderManagement);
        } else {
            $this->RemainderManagement = $remainderManagement;
        }
        return $this;
    }
    /**
     * Get SalespersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalespersonId()
    {
        return isset($this->SalespersonId) ? $this->SalespersonId : null;
    }
    /**
     * Set SalespersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salespersonId
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setSalespersonId($salespersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salespersonId) && !is_string($salespersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salespersonId, true), gettype($salespersonId)), __LINE__);
        }
        if (is_null($salespersonId) || (is_array($salespersonId) && empty($salespersonId))) {
            unset($this->SalespersonId);
        } else {
            $this->SalespersonId = $salespersonId;
        }
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \Cegid\EnumType\CustomerOrderDocumentTypeCreat2::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderDocumentTypeCreat2::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderDocumentTypeCreat2::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderDocumentTypeCreat2', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \Cegid\EnumType\CustomerOrderDocumentTypeCreat2::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get UserDefined value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserDefined|null
     */
    public function getUserDefined()
    {
        return isset($this->UserDefined) ? $this->UserDefined : null;
    }
    /**
     * Set UserDefined value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserDefined $userDefined
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setUserDefined(\Cegid\StructType\CreateFrom2RequestHeaderUserDefined $userDefined = null)
    {
        if (is_null($userDefined) || (is_array($userDefined) && empty($userDefined))) {
            unset($this->UserDefined);
        } else {
            $this->UserDefined = $userDefined;
        }
        return $this;
    }
    /**
     * Get UserFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection|null
     */
    public function getUserFields()
    {
        return isset($this->UserFields) ? $this->UserFields : null;
    }
    /**
     * Set UserFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection $userFields
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setUserFields(\Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection $userFields = null)
    {
        if (is_null($userFields) || (is_array($userFields) && empty($userFields))) {
            unset($this->UserFields);
        } else {
            $this->UserFields = $userFields;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->WarehouseId) ? $this->WarehouseId : null;
    }
    /**
     * Set WarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \Cegid\StructType\CreateFrom2RequestHeader
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->WarehouseId);
        } else {
            $this->WarehouseId = $warehouseId;
        }
        return $this;
    }
}
