<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFrom2RequestHeaderUserDefinedCustomerTableCollection
 * StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFrom2RequestHeaderUserDefinedCustomerTableCollection
 * @subpackage Structs
 */
class CreateFrom2RequestHeaderUserDefinedCustomerTableCollection extends AbstractStructBase
{
    /**
     * The CustomerTable
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable[]
     */
    public $CustomerTable;
    /**
     * Constructor method for
     * CreateFrom2RequestHeaderUserDefinedCustomerTableCollection
     * @uses CreateFrom2RequestHeaderUserDefinedCustomerTableCollection::setCustomerTable()
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable[] $customerTable
     */
    public function __construct(array $customerTable = array())
    {
        $this
            ->setCustomerTable($customerTable);
    }
    /**
     * Get CustomerTable value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable[]|null
     */
    public function getCustomerTable()
    {
        return isset($this->CustomerTable) ? $this->CustomerTable : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerTable method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerTable method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerTableForArrayConstraintsFromSetCustomerTable(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem) {
            // validation for constraint: itemType
            if (!$createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem instanceof \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable) {
                $invalidValues[] = is_object($createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem) ? get_class($createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem) : sprintf('%s(%s)', gettype($createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem), var_export($createFrom2RequestHeaderUserDefinedCustomerTableCollectionCustomerTableItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerTable property can only contain items of type \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerTable value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable[] $customerTable
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTableCollection
     */
    public function setCustomerTable(array $customerTable = array())
    {
        // validation for constraint: array
        if ('' !== ($customerTableArrayErrorMessage = self::validateCustomerTableForArrayConstraintsFromSetCustomerTable($customerTable))) {
            throw new \InvalidArgumentException($customerTableArrayErrorMessage, __LINE__);
        }
        if (is_null($customerTable) || (is_array($customerTable) && empty($customerTable))) {
            unset($this->CustomerTable);
        } else {
            $this->CustomerTable = $customerTable;
        }
        return $this;
    }
    /**
     * Add item to CustomerTable value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable $item
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTableCollection
     */
    public function addToCustomerTable(\Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable) {
            throw new \InvalidArgumentException(sprintf('The CustomerTable property can only contain items of type \Cegid\StructType\CreateFrom2RequestHeaderUserDefinedCustomerTable, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerTable[] = $item;
        return $this;
    }
}
