<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFrom2RequestHeaderUserFieldCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFrom2RequestHeaderUserFieldCollection
 * @subpackage Structs
 */
class CreateFrom2RequestHeaderUserFieldCollection extends AbstractStructBase
{
    /**
     * The UserField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFrom2RequestHeaderUserField[]
     */
    public $UserField;
    /**
     * Constructor method for CreateFrom2RequestHeaderUserFieldCollection
     * @uses CreateFrom2RequestHeaderUserFieldCollection::setUserField()
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserField[] $userField
     */
    public function __construct(array $userField = array())
    {
        $this
            ->setUserField($userField);
    }
    /**
     * Get UserField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserField[]|null
     */
    public function getUserField()
    {
        return isset($this->UserField) ? $this->UserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserFieldForArrayConstraintsFromSetUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFrom2RequestHeaderUserFieldCollectionUserFieldItem) {
            // validation for constraint: itemType
            if (!$createFrom2RequestHeaderUserFieldCollectionUserFieldItem instanceof \Cegid\StructType\CreateFrom2RequestHeaderUserField) {
                $invalidValues[] = is_object($createFrom2RequestHeaderUserFieldCollectionUserFieldItem) ? get_class($createFrom2RequestHeaderUserFieldCollectionUserFieldItem) : sprintf('%s(%s)', gettype($createFrom2RequestHeaderUserFieldCollectionUserFieldItem), var_export($createFrom2RequestHeaderUserFieldCollectionUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserField property can only contain items of type \Cegid\StructType\CreateFrom2RequestHeaderUserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserField[] $userField
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection
     */
    public function setUserField(array $userField = array())
    {
        // validation for constraint: array
        if ('' !== ($userFieldArrayErrorMessage = self::validateUserFieldForArrayConstraintsFromSetUserField($userField))) {
            throw new \InvalidArgumentException($userFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($userField) || (is_array($userField) && empty($userField))) {
            unset($this->UserField);
        } else {
            $this->UserField = $userField;
        }
        return $this;
    }
    /**
     * Add item to UserField value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateFrom2RequestHeaderUserField $item
     * @return \Cegid\StructType\CreateFrom2RequestHeaderUserFieldCollection
     */
    public function addToUserField(\Cegid\StructType\CreateFrom2RequestHeaderUserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\CreateFrom2RequestHeaderUserField) {
            throw new \InvalidArgumentException(sprintf('The UserField property can only contain items of type \Cegid\StructType\CreateFrom2RequestHeaderUserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserField[] = $item;
        return $this;
    }
}
