<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromReply StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromReply
 * @subpackage Structs
 */
class CreateFromReply extends AbstractStructBase
{
    /**
     * The DocumentCreated
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $DocumentCreated;
    /**
     * The Documents
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\CreateFromReplyDocumentCollection
     */
    public $Documents;
    /**
     * Constructor method for CreateFromReply
     * @uses CreateFromReply::setDocumentCreated()
     * @uses CreateFromReply::setDocuments()
     * @param bool $documentCreated
     * @param \Cegid\StructType\CreateFromReplyDocumentCollection $documents
     */
    public function __construct($documentCreated = null, \Cegid\StructType\CreateFromReplyDocumentCollection $documents = null)
    {
        $this
            ->setDocumentCreated($documentCreated)
            ->setDocuments($documents);
    }
    /**
     * Get DocumentCreated value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getDocumentCreated()
    {
        return isset($this->DocumentCreated) ? $this->DocumentCreated : null;
    }
    /**
     * Set DocumentCreated value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $documentCreated
     * @return \Cegid\StructType\CreateFromReply
     */
    public function setDocumentCreated($documentCreated = null)
    {
        // validation for constraint: boolean
        if (!is_null($documentCreated) && !is_bool($documentCreated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($documentCreated, true), gettype($documentCreated)), __LINE__);
        }
        if (is_null($documentCreated) || (is_array($documentCreated) && empty($documentCreated))) {
            unset($this->DocumentCreated);
        } else {
            $this->DocumentCreated = $documentCreated;
        }
        return $this;
    }
    /**
     * Get Documents value
     * @return \Cegid\StructType\CreateFromReplyDocumentCollection|null
     */
    public function getDocuments()
    {
        return $this->Documents;
    }
    /**
     * Set Documents value
     * @param \Cegid\StructType\CreateFromReplyDocumentCollection $documents
     * @return \Cegid\StructType\CreateFromReply
     */
    public function setDocuments(\Cegid\StructType\CreateFromReplyDocumentCollection $documents = null)
    {
        $this->Documents = $documents;
        return $this;
    }
}
