<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequest
 * @subpackage Structs
 */
class CreateFromRequest extends AbstractStructBase
{
    /**
     * The Header
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\CreateFromRequestHeader
     */
    public $Header;
    /**
     * The Lines
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFromRequestLineCollection
     */
    public $Lines;
    /**
     * The Payments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateFromRequestPaymentCollection
     */
    public $Payments;
    /**
     * Constructor method for CreateFromRequest
     * @uses CreateFromRequest::setHeader()
     * @uses CreateFromRequest::setLines()
     * @uses CreateFromRequest::setPayments()
     * @param \Cegid\StructType\CreateFromRequestHeader $header
     * @param \Cegid\StructType\CreateFromRequestLineCollection $lines
     * @param \Cegid\StructType\CreateFromRequestPaymentCollection $payments
     */
    public function __construct(\Cegid\StructType\CreateFromRequestHeader $header = null, \Cegid\StructType\CreateFromRequestLineCollection $lines = null, \Cegid\StructType\CreateFromRequestPaymentCollection $payments = null)
    {
        $this
            ->setHeader($header)
            ->setLines($lines)
            ->setPayments($payments);
    }
    /**
     * Get Header value
     * @return \Cegid\StructType\CreateFromRequestHeader|null
     */
    public function getHeader()
    {
        return $this->Header;
    }
    /**
     * Set Header value
     * @param \Cegid\StructType\CreateFromRequestHeader $header
     * @return \Cegid\StructType\CreateFromRequest
     */
    public function setHeader(\Cegid\StructType\CreateFromRequestHeader $header = null)
    {
        $this->Header = $header;
        return $this;
    }
    /**
     * Get Lines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFromRequestLineCollection|null
     */
    public function getLines()
    {
        return isset($this->Lines) ? $this->Lines : null;
    }
    /**
     * Set Lines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFromRequestLineCollection $lines
     * @return \Cegid\StructType\CreateFromRequest
     */
    public function setLines(\Cegid\StructType\CreateFromRequestLineCollection $lines = null)
    {
        if (is_null($lines) || (is_array($lines) && empty($lines))) {
            unset($this->Lines);
        } else {
            $this->Lines = $lines;
        }
        return $this;
    }
    /**
     * Get Payments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateFromRequestPaymentCollection|null
     */
    public function getPayments()
    {
        return isset($this->Payments) ? $this->Payments : null;
    }
    /**
     * Set Payments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CreateFromRequestPaymentCollection $payments
     * @return \Cegid\StructType\CreateFromRequest
     */
    public function setPayments(\Cegid\StructType\CreateFromRequestPaymentCollection $payments = null)
    {
        if (is_null($payments) || (is_array($payments) && empty($payments))) {
            unset($this->Payments);
        } else {
            $this->Payments = $payments;
        }
        return $this;
    }
}
