<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateRequestHeaderReferences StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateRequestHeaderReferences
 * @subpackage Structs
 */
class CreateRequestHeaderReferences extends AbstractStructBase
{
    /**
     * The External
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $External;
    /**
     * The FollowUp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowUp;
    /**
     * The Internal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Internal;
    /**
     * Constructor method for CreateRequestHeaderReferences
     * @uses CreateRequestHeaderReferences::setExternal()
     * @uses CreateRequestHeaderReferences::setFollowUp()
     * @uses CreateRequestHeaderReferences::setInternal()
     * @param string $external
     * @param string $followUp
     * @param string $internal
     */
    public function __construct($external = null, $followUp = null, $internal = null)
    {
        $this
            ->setExternal($external)
            ->setFollowUp($followUp)
            ->setInternal($internal);
    }
    /**
     * Get External value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternal()
    {
        return isset($this->External) ? $this->External : null;
    }
    /**
     * Set External value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $external
     * @return \Cegid\StructType\CreateRequestHeaderReferences
     */
    public function setExternal($external = null)
    {
        // validation for constraint: string
        if (!is_null($external) && !is_string($external)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($external, true), gettype($external)), __LINE__);
        }
        if (is_null($external) || (is_array($external) && empty($external))) {
            unset($this->External);
        } else {
            $this->External = $external;
        }
        return $this;
    }
    /**
     * Get FollowUp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowUp()
    {
        return isset($this->FollowUp) ? $this->FollowUp : null;
    }
    /**
     * Set FollowUp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followUp
     * @return \Cegid\StructType\CreateRequestHeaderReferences
     */
    public function setFollowUp($followUp = null)
    {
        // validation for constraint: string
        if (!is_null($followUp) && !is_string($followUp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followUp, true), gettype($followUp)), __LINE__);
        }
        if (is_null($followUp) || (is_array($followUp) && empty($followUp))) {
            unset($this->FollowUp);
        } else {
            $this->FollowUp = $followUp;
        }
        return $this;
    }
    /**
     * Get Internal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInternal()
    {
        return isset($this->Internal) ? $this->Internal : null;
    }
    /**
     * Set Internal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $internal
     * @return \Cegid\StructType\CreateRequestHeaderReferences
     */
    public function setInternal($internal = null)
    {
        // validation for constraint: string
        if (!is_null($internal) && !is_string($internal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internal, true), gettype($internal)), __LINE__);
        }
        if (is_null($internal) || (is_array($internal) && empty($internal))) {
            unset($this->Internal);
        } else {
            $this->Internal = $internal;
        }
        return $this;
    }
}
