<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateRequestHeaderUserDefinedTableCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateRequestHeaderUserDefinedTableCollection
 * @subpackage Structs
 */
class CreateRequestHeaderUserDefinedTableCollection extends AbstractStructBase
{
    /**
     * The Table
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CreateRequestHeaderUserDefinedTable[]
     */
    public $Table;
    /**
     * Constructor method for CreateRequestHeaderUserDefinedTableCollection
     * @uses CreateRequestHeaderUserDefinedTableCollection::setTable()
     * @param \Cegid\StructType\CreateRequestHeaderUserDefinedTable[] $table
     */
    public function __construct(array $table = array())
    {
        $this
            ->setTable($table);
    }
    /**
     * Get Table value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CreateRequestHeaderUserDefinedTable[]|null
     */
    public function getTable()
    {
        return isset($this->Table) ? $this->Table : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTable method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTable method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTableForArrayConstraintsFromSetTable(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createRequestHeaderUserDefinedTableCollectionTableItem) {
            // validation for constraint: itemType
            if (!$createRequestHeaderUserDefinedTableCollectionTableItem instanceof \Cegid\StructType\CreateRequestHeaderUserDefinedTable) {
                $invalidValues[] = is_object($createRequestHeaderUserDefinedTableCollectionTableItem) ? get_class($createRequestHeaderUserDefinedTableCollectionTableItem) : sprintf('%s(%s)', gettype($createRequestHeaderUserDefinedTableCollectionTableItem), var_export($createRequestHeaderUserDefinedTableCollectionTableItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Table property can only contain items of type \Cegid\StructType\CreateRequestHeaderUserDefinedTable, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Table value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateRequestHeaderUserDefinedTable[] $table
     * @return \Cegid\StructType\CreateRequestHeaderUserDefinedTableCollection
     */
    public function setTable(array $table = array())
    {
        // validation for constraint: array
        if ('' !== ($tableArrayErrorMessage = self::validateTableForArrayConstraintsFromSetTable($table))) {
            throw new \InvalidArgumentException($tableArrayErrorMessage, __LINE__);
        }
        if (is_null($table) || (is_array($table) && empty($table))) {
            unset($this->Table);
        } else {
            $this->Table = $table;
        }
        return $this;
    }
    /**
     * Add item to Table value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\CreateRequestHeaderUserDefinedTable $item
     * @return \Cegid\StructType\CreateRequestHeaderUserDefinedTableCollection
     */
    public function addToTable(\Cegid\StructType\CreateRequestHeaderUserDefinedTable $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\CreateRequestHeaderUserDefinedTable) {
            throw new \InvalidArgumentException(sprintf('The Table property can only contain items of type \Cegid\StructType\CreateRequestHeaderUserDefinedTable, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Table[] = $item;
        return $this;
    }
}
