<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerOrderHeaderCustomer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CustomerOrderHeaderCustomer
 * @subpackage Structs
 */
class CustomerOrderHeaderCustomer extends AbstractStructBase
{
    /**
     * The Emails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection
     */
    public $Emails;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $FirstName;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Id;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $LastName;
    /**
     * The Phones
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection
     */
    public $Phones;
    /**
     * Constructor method for CustomerOrderHeaderCustomer
     * @uses CustomerOrderHeaderCustomer::setEmails()
     * @uses CustomerOrderHeaderCustomer::setFirstName()
     * @uses CustomerOrderHeaderCustomer::setId()
     * @uses CustomerOrderHeaderCustomer::setLastName()
     * @uses CustomerOrderHeaderCustomer::setPhones()
     * @param \Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection $emails
     * @param string $firstName
     * @param string $id
     * @param string $lastName
     * @param \Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection $phones
     */
    public function __construct(\Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection $emails = null, $firstName = null, $id = null, $lastName = null, \Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection $phones = null)
    {
        $this
            ->setEmails($emails)
            ->setFirstName($firstName)
            ->setId($id)
            ->setLastName($lastName)
            ->setPhones($phones);
    }
    /**
     * Get Emails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection|null
     */
    public function getEmails()
    {
        return isset($this->Emails) ? $this->Emails : null;
    }
    /**
     * Set Emails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection $emails
     * @return \Cegid\StructType\CustomerOrderHeaderCustomer
     */
    public function setEmails(\Cegid\StructType\CustomerOrderHeaderCustomerEmailCollection $emails = null)
    {
        if (is_null($emails) || (is_array($emails) && empty($emails))) {
            unset($this->Emails);
        } else {
            $this->Emails = $emails;
        }
        return $this;
    }
    /**
     * Get FirstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \Cegid\StructType\CustomerOrderHeaderCustomer
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \Cegid\StructType\CustomerOrderHeaderCustomer
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get LastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \Cegid\StructType\CustomerOrderHeaderCustomer
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get Phones value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection|null
     */
    public function getPhones()
    {
        return isset($this->Phones) ? $this->Phones : null;
    }
    /**
     * Set Phones value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection $phones
     * @return \Cegid\StructType\CustomerOrderHeaderCustomer
     */
    public function setPhones(\Cegid\StructType\CustomerOrderHeaderCustomerPhoneCollection $phones = null)
    {
        if (is_null($phones) || (is_array($phones) && empty($phones))) {
            unset($this->Phones);
        } else {
            $this->Phones = $phones;
        }
        return $this;
    }
}
