<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerOrderHeaderOmniChannelGiftMessage StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CustomerOrderHeaderOmniChannelGiftMessage
 * @subpackage Structs
 */
class CustomerOrderHeaderOmniChannelGiftMessage extends AbstractStructBase
{
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Message;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for CustomerOrderHeaderOmniChannelGiftMessage
     * @uses CustomerOrderHeaderOmniChannelGiftMessage::setMessage()
     * @uses CustomerOrderHeaderOmniChannelGiftMessage::setType()
     * @param string $message
     * @param string $type
     */
    public function __construct($message = null, $type = null)
    {
        $this
            ->setMessage($message)
            ->setType($type);
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \Cegid\StructType\CustomerOrderHeaderOmniChannelGiftMessage
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \Cegid\EnumType\GiftMessageType::valueIsValid()
     * @uses \Cegid\EnumType\GiftMessageType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \Cegid\StructType\CustomerOrderHeaderOmniChannelGiftMessage
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\GiftMessageType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\GiftMessageType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \Cegid\EnumType\GiftMessageType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
}
