<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReplaceRequestHeaderCustomer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReplaceRequestHeaderCustomer
 * @subpackage Structs
 */
class ReplaceRequestHeaderCustomer extends AbstractStructBase
{
    /**
     * The Addresses
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection
     */
    public $Addresses;
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier
     */
    public $Identifier;
    /**
     * The TaxSystemId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $TaxSystemId;
    /**
     * Constructor method for ReplaceRequestHeaderCustomer
     * @uses ReplaceRequestHeaderCustomer::setAddresses()
     * @uses ReplaceRequestHeaderCustomer::setIdentifier()
     * @uses ReplaceRequestHeaderCustomer::setTaxSystemId()
     * @param \Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection $addresses
     * @param \Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier $identifier
     * @param string $taxSystemId
     */
    public function __construct(\Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection $addresses = null, \Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier $identifier = null, $taxSystemId = null)
    {
        $this
            ->setAddresses($addresses)
            ->setIdentifier($identifier)
            ->setTaxSystemId($taxSystemId);
    }
    /**
     * Get Addresses value
     * @return \Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection|null
     */
    public function getAddresses()
    {
        return $this->Addresses;
    }
    /**
     * Set Addresses value
     * @param \Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection $addresses
     * @return \Cegid\StructType\ReplaceRequestHeaderCustomer
     */
    public function setAddresses(\Cegid\StructType\ReplaceRequestHeaderCustomerAddressCollection $addresses = null)
    {
        $this->Addresses = $addresses;
        return $this;
    }
    /**
     * Get Identifier value
     * @return \Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier|null
     */
    public function getIdentifier()
    {
        return $this->Identifier;
    }
    /**
     * Set Identifier value
     * @param \Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier $identifier
     * @return \Cegid\StructType\ReplaceRequestHeaderCustomer
     */
    public function setIdentifier(\Cegid\StructType\ReplaceRequestHeaderCustomerIdentifier $identifier = null)
    {
        $this->Identifier = $identifier;
        return $this;
    }
    /**
     * Get TaxSystemId value
     * @return string|null
     */
    public function getTaxSystemId()
    {
        return $this->TaxSystemId;
    }
    /**
     * Set TaxSystemId value
     * @param string $taxSystemId
     * @return \Cegid\StructType\ReplaceRequestHeaderCustomer
     */
    public function setTaxSystemId($taxSystemId = null)
    {
        // validation for constraint: string
        if (!is_null($taxSystemId) && !is_string($taxSystemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxSystemId, true), gettype($taxSystemId)), __LINE__);
        }
        $this->TaxSystemId = $taxSystemId;
        return $this;
    }
}
