<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReplaceRequestHeaderKey StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReplaceRequestHeaderKey
 * @subpackage Structs
 */
class ReplaceRequestHeaderKey extends AbstractStructBase
{
    /**
     * The Number
     * @var int
     */
    public $Number;
    /**
     * The Stub
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Stub;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for ReplaceRequestHeaderKey
     * @uses ReplaceRequestHeaderKey::setNumber()
     * @uses ReplaceRequestHeaderKey::setStub()
     * @uses ReplaceRequestHeaderKey::setType()
     * @param int $number
     * @param string $stub
     * @param string $type
     */
    public function __construct($number = null, $stub = null, $type = null)
    {
        $this
            ->setNumber($number)
            ->setStub($stub)
            ->setType($type);
    }
    /**
     * Get Number value
     * @return int|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param int $number
     * @return \Cegid\StructType\ReplaceRequestHeaderKey
     */
    public function setNumber($number = null)
    {
        // validation for constraint: int
        if (!is_null($number) && !(is_int($number) || ctype_digit($number))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get Stub value
     * @return string|null
     */
    public function getStub()
    {
        return $this->Stub;
    }
    /**
     * Set Stub value
     * @param string $stub
     * @return \Cegid\StructType\ReplaceRequestHeaderKey
     */
    public function setStub($stub = null)
    {
        // validation for constraint: string
        if (!is_null($stub) && !is_string($stub)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stub, true), gettype($stub)), __LINE__);
        }
        $this->Stub = $stub;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \Cegid\EnumType\CustomerOrderDocumentTypeReplace::valueIsValid()
     * @uses \Cegid\EnumType\CustomerOrderDocumentTypeReplace::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \Cegid\StructType\ReplaceRequestHeaderKey
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\Cegid\EnumType\CustomerOrderDocumentTypeReplace::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Cegid\EnumType\CustomerOrderDocumentTypeReplace', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \Cegid\EnumType\CustomerOrderDocumentTypeReplace::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
}
