<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReplaceRequestLine StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReplaceRequestLine
 * @subpackage Structs
 */
class ReplaceRequestLine extends AbstractStructBase
{
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\ReplaceRequestLineComment
     */
    public $Comment;
    /**
     * The Id
     * @var int
     */
    public $Id;
    /**
     * The Product
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\ReplaceRequestLineProduct
     */
    public $Product;
    /**
     * Constructor method for ReplaceRequestLine
     * @uses ReplaceRequestLine::setComment()
     * @uses ReplaceRequestLine::setId()
     * @uses ReplaceRequestLine::setProduct()
     * @param \Cegid\StructType\ReplaceRequestLineComment $comment
     * @param int $id
     * @param \Cegid\StructType\ReplaceRequestLineProduct $product
     */
    public function __construct(\Cegid\StructType\ReplaceRequestLineComment $comment = null, $id = null, \Cegid\StructType\ReplaceRequestLineProduct $product = null)
    {
        $this
            ->setComment($comment)
            ->setId($id)
            ->setProduct($product);
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\ReplaceRequestLineComment|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\ReplaceRequestLineComment $comment
     * @return \Cegid\StructType\ReplaceRequestLine
     */
    public function setComment(\Cegid\StructType\ReplaceRequestLineComment $comment = null)
    {
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \Cegid\StructType\ReplaceRequestLine
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Product value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\ReplaceRequestLineProduct|null
     */
    public function getProduct()
    {
        return isset($this->Product) ? $this->Product : null;
    }
    /**
     * Set Product value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Cegid\StructType\ReplaceRequestLineProduct $product
     * @return \Cegid\StructType\ReplaceRequestLine
     */
    public function setProduct(\Cegid\StructType\ReplaceRequestLineProduct $product = null)
    {
        if (is_null($product) || (is_array($product) && empty($product))) {
            unset($this->Product);
        } else {
            $this->Product = $product;
        }
        return $this;
    }
}
