<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReplaceRequestLineProductReferences StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ReplaceRequestLineProductReferences
 * @subpackage Structs
 */
class ReplaceRequestLineProductReferences extends AbstractStructBase
{
    /**
     * The Catalog
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Catalog;
    /**
     * The External
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $External;
    /**
     * The Package
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Package;
    /**
     * Constructor method for ReplaceRequestLineProductReferences
     * @uses ReplaceRequestLineProductReferences::setCatalog()
     * @uses ReplaceRequestLineProductReferences::setExternal()
     * @uses ReplaceRequestLineProductReferences::setPackage()
     * @param string $catalog
     * @param string $external
     * @param string $package
     */
    public function __construct($catalog = null, $external = null, $package = null)
    {
        $this
            ->setCatalog($catalog)
            ->setExternal($external)
            ->setPackage($package);
    }
    /**
     * Get Catalog value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCatalog()
    {
        return isset($this->Catalog) ? $this->Catalog : null;
    }
    /**
     * Set Catalog value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $catalog
     * @return \Cegid\StructType\ReplaceRequestLineProductReferences
     */
    public function setCatalog($catalog = null)
    {
        // validation for constraint: string
        if (!is_null($catalog) && !is_string($catalog)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($catalog, true), gettype($catalog)), __LINE__);
        }
        if (is_null($catalog) || (is_array($catalog) && empty($catalog))) {
            unset($this->Catalog);
        } else {
            $this->Catalog = $catalog;
        }
        return $this;
    }
    /**
     * Get External value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternal()
    {
        return isset($this->External) ? $this->External : null;
    }
    /**
     * Set External value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $external
     * @return \Cegid\StructType\ReplaceRequestLineProductReferences
     */
    public function setExternal($external = null)
    {
        // validation for constraint: string
        if (!is_null($external) && !is_string($external)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($external, true), gettype($external)), __LINE__);
        }
        if (is_null($external) || (is_array($external) && empty($external))) {
            unset($this->External);
        } else {
            $this->External = $external;
        }
        return $this;
    }
    /**
     * Get Package value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPackage()
    {
        return isset($this->Package) ? $this->Package : null;
    }
    /**
     * Set Package value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $package
     * @return \Cegid\StructType\ReplaceRequestLineProductReferences
     */
    public function setPackage($package = null)
    {
        // validation for constraint: string
        if (!is_null($package) && !is_string($package)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($package, true), gettype($package)), __LINE__);
        }
        if (is_null($package) || (is_array($package) && empty($package))) {
            unset($this->Package);
        } else {
            $this->Package = $package;
        }
        return $this;
    }
}
