<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateRequestHeaderUserDefinedDateCollection StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UpdateRequestHeaderUserDefinedDateCollection
 * @subpackage Structs
 */
class UpdateRequestHeaderUserDefinedDateCollection extends AbstractStructBase
{
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Cegid\StructType\UpdateRequestHeaderUserDefinedDate[]
     */
    public $Date;
    /**
     * Constructor method for UpdateRequestHeaderUserDefinedDateCollection
     * @uses UpdateRequestHeaderUserDefinedDateCollection::setDate()
     * @param \Cegid\StructType\UpdateRequestHeaderUserDefinedDate[] $date
     */
    public function __construct(array $date = array())
    {
        $this
            ->setDate($date);
    }
    /**
     * Get Date value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Cegid\StructType\UpdateRequestHeaderUserDefinedDate[]|null
     */
    public function getDate()
    {
        return isset($this->Date) ? $this->Date : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDateForArrayConstraintsFromSetDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateRequestHeaderUserDefinedDateCollectionDateItem) {
            // validation for constraint: itemType
            if (!$updateRequestHeaderUserDefinedDateCollectionDateItem instanceof \Cegid\StructType\UpdateRequestHeaderUserDefinedDate) {
                $invalidValues[] = is_object($updateRequestHeaderUserDefinedDateCollectionDateItem) ? get_class($updateRequestHeaderUserDefinedDateCollectionDateItem) : sprintf('%s(%s)', gettype($updateRequestHeaderUserDefinedDateCollectionDateItem), var_export($updateRequestHeaderUserDefinedDateCollectionDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Date property can only contain items of type \Cegid\StructType\UpdateRequestHeaderUserDefinedDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Date value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\UpdateRequestHeaderUserDefinedDate[] $date
     * @return \Cegid\StructType\UpdateRequestHeaderUserDefinedDateCollection
     */
    public function setDate(array $date = array())
    {
        // validation for constraint: array
        if ('' !== ($dateArrayErrorMessage = self::validateDateForArrayConstraintsFromSetDate($date))) {
            throw new \InvalidArgumentException($dateArrayErrorMessage, __LINE__);
        }
        if (is_null($date) || (is_array($date) && empty($date))) {
            unset($this->Date);
        } else {
            $this->Date = $date;
        }
        return $this;
    }
    /**
     * Add item to Date value
     * @throws \InvalidArgumentException
     * @param \Cegid\StructType\UpdateRequestHeaderUserDefinedDate $item
     * @return \Cegid\StructType\UpdateRequestHeaderUserDefinedDateCollection
     */
    public function addToDate(\Cegid\StructType\UpdateRequestHeaderUserDefinedDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Cegid\StructType\UpdateRequestHeaderUserDefinedDate) {
            throw new \InvalidArgumentException(sprintf('The Date property can only contain items of type \Cegid\StructType\UpdateRequestHeaderUserDefinedDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Date[] = $item;
        return $this;
    }
}
