<?php

namespace Cegid\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserFieldForPostValue StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UserFieldForPostValue
 * @subpackage Structs
 */
class UserFieldForPostValue extends AbstractStructBase
{
    /**
     * The Boolean
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Boolean;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Date;
    /**
     * The ListElement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ListElement;
    /**
     * The Number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $Number;
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Text;
    /**
     * Constructor method for UserFieldForPostValue
     * @uses UserFieldForPostValue::setBoolean()
     * @uses UserFieldForPostValue::setDate()
     * @uses UserFieldForPostValue::setListElement()
     * @uses UserFieldForPostValue::setNumber()
     * @uses UserFieldForPostValue::setText()
     * @param bool $boolean
     * @param string $date
     * @param string $listElement
     * @param float $number
     * @param string $text
     */
    public function __construct($boolean = null, $date = null, $listElement = null, $number = null, $text = null)
    {
        $this
            ->setBoolean($boolean)
            ->setDate($date)
            ->setListElement($listElement)
            ->setNumber($number)
            ->setText($text);
    }
    /**
     * Get Boolean value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getBoolean()
    {
        return isset($this->Boolean) ? $this->Boolean : null;
    }
    /**
     * Set Boolean value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $boolean
     * @return \Cegid\StructType\UserFieldForPostValue
     */
    public function setBoolean($boolean = null)
    {
        // validation for constraint: boolean
        if (!is_null($boolean) && !is_bool($boolean)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($boolean, true), gettype($boolean)), __LINE__);
        }
        if (is_null($boolean) || (is_array($boolean) && empty($boolean))) {
            unset($this->Boolean);
        } else {
            $this->Boolean = $boolean;
        }
        return $this;
    }
    /**
     * Get Date value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDate()
    {
        return isset($this->Date) ? $this->Date : null;
    }
    /**
     * Set Date value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $date
     * @return \Cegid\StructType\UserFieldForPostValue
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        if (is_null($date) || (is_array($date) && empty($date))) {
            unset($this->Date);
        } else {
            $this->Date = $date;
        }
        return $this;
    }
    /**
     * Get ListElement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getListElement()
    {
        return isset($this->ListElement) ? $this->ListElement : null;
    }
    /**
     * Set ListElement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $listElement
     * @return \Cegid\StructType\UserFieldForPostValue
     */
    public function setListElement($listElement = null)
    {
        // validation for constraint: string
        if (!is_null($listElement) && !is_string($listElement)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($listElement, true), gettype($listElement)), __LINE__);
        }
        if (is_null($listElement) || (is_array($listElement) && empty($listElement))) {
            unset($this->ListElement);
        } else {
            $this->ListElement = $listElement;
        }
        return $this;
    }
    /**
     * Get Number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getNumber()
    {
        return isset($this->Number) ? $this->Number : null;
    }
    /**
     * Set Number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $number
     * @return \Cegid\StructType\UserFieldForPostValue
     */
    public function setNumber($number = null)
    {
        // validation for constraint: float
        if (!is_null($number) && !(is_float($number) || is_numeric($number))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        if (is_null($number) || (is_array($number) && empty($number))) {
            unset($this->Number);
        } else {
            $this->Number = $number;
        }
        return $this;
    }
    /**
     * Get Text value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getText()
    {
        return isset($this->Text) ? $this->Text : null;
    }
    /**
     * Set Text value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $text
     * @return \Cegid\StructType\UserFieldForPostValue
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($text, true), gettype($text)), __LINE__);
        }
        if (is_null($text) || (is_array($text) && empty($text))) {
            unset($this->Text);
        } else {
            $this->Text = $text;
        }
        return $this;
    }
}
